package com.gzzm.gd_oa_interface.service.document;

package ..deTemp.1733910202809;

import com.gzzm.gd_oa_interface.GdOAException;
import com.gzzm.gd_oa_interface.base.DocumentConstant;
import com.gzzm.gd_oa_interface.dto.document.Attachment;
import com.gzzm.gd_oa_interface.dto.document.Attrs;
import com.gzzm.gd_oa_interface.dto.document.Doc;
import com.gzzm.gd_oa_interface.dto.document.DocBody;
import com.gzzm.gd_oa_interface.dto.document.DocBodyExt;
import com.gzzm.gd_oa_interface.dto.document.Extend;
import com.gzzm.gd_oa_interface.dto.document.Header;
import com.gzzm.gd_oa_interface.dto.document.IdentificationOfDocumentIssuer;
import com.gzzm.gd_oa_interface.dto.document.IssuedNumberOfDocument;
import com.gzzm.gd_oa_interface.dto.document.MainBody;
import com.gzzm.gd_oa_interface.dto.document.ReceiverDepartment;
import com.gzzm.gd_oa_interface.dto.document.SecurityClassificationAndDuration;
import com.gzzm.gd_oa_interface.dto.document.Segment;
import com.gzzm.gd_oa_interface.dto.document.SegmentContent;
import com.gzzm.gd_oa_interface.dto.document.SegmentRET;
import com.gzzm.gd_oa_interface.dto.document.SendMainDoc;
import com.gzzm.gd_oa_interface.dto.document.SendShortDoc;
import com.gzzm.gd_oa_interface.dto.document.SenderDepartment;
import com.gzzm.gd_oa_interface.dto.document.SignatureOfDocumentIssuingAgency;
import com.gzzm.gd_oa_interface.dto.document.Tail;
import com.gzzm.gd_oa_interface.entity.ErrorLog;
import com.gzzm.gd_oa_interface.entity.document.ExchangeSend;
import com.gzzm.gd_oa_interface.entity.document.ReceiveRecord;
import com.gzzm.gd_oa_interface.entity.document.SendRecord;
import com.gzzm.gd_oa_interface.entity.document.SendSynLog;
import com.gzzm.gd_oa_interface.entity.organization.GdOAExchangeDept;
import com.gzzm.gd_oa_interface.enums.SynTag;
import com.gzzm.gd_oa_interface.service.BaseService;
import com.gzzm.gd_oa_interface.util.FileUtils;
import com.gzzm.gd_oa_interface.util.ResultUtils;
import com.gzzm.gd_oa_interface.util.SynTools;
import com.gzzm.gd_oa_interface.util.TimeUtils;
import com.gzzm.ods.document.DocumentText;
import com.gzzm.ods.document.OfficeDocument;
import com.gzzm.ods.exchange.Back;
import com.gzzm.ods.exchange.ReceiveBase;
import com.gzzm.ods.exchange.ReceiveState;
import com.gzzm.ods.exchange.Send;
import com.gzzm.ods.exchange.SendState;
import com.gzzm.platform.attachment.Attachment;
import com.gzzm.platform.attachment.AttachmentDao;
import com.gzzm.platform.commons.Tools;
import java.io.InputStream;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import net.cyan.commons.transaction.Transactional;
import net.cyan.commons.util.CollectionUtils;
import net.cyan.commons.util.Null;
import net.cyan.commons.util.StringUtils;
import net.cyan.commons.util.json.JsonObject;
import net.cyan.commons.util.json.JsonParser;
import net.cyan.commons.util.json.JsonSerializer;
import net.cyan.nest.annotation.Inject;

public class SendService extends BaseService {
  public static String sendOFC = "/ebus/sgbackend/api/r/bc/odexchangesys/SendMainDoc";
  
  public static String sendRET = "/ebus/sgbackend/api/r/bc/odexchangesys/SendShortDoc";
  
  @Inject
  protected AttachmentDao attachmentDao;
  
  @Transactional
  public void sendOFC(List<ReceiveBase> receiveBaseList, OfficeDocument document, Send send) throws Exception {
    SendMainDoc sendMainDoc = createSendMainDoc(receiveBaseList, document, send);
    String jsonStr = SynTools.doPost(sendOFC, sendMainDoc);
    JsonObject json = (JsonObject)(new JsonParser(jsonStr)).parse();
    boolean successTag = ResultUtils.isExchangePlatformSuccess(json);
    SendSynLog log = new SendSynLog(((JsonSerializer)(new JsonSerializer()).serialize(sendMainDoc)).toString().toCharArray(), jsonStr.toCharArray(), document.getDocumentId(), sendOFC, successTag);
    this.dao.save(log);
    if (successTag) {
      String segmentId = ((JsonObject)json.get("data")).getString("segment_id");
      for (ReceiveBase receiveBase : receiveBaseList) {
        this.dao.save(new SendRecord(segmentId, receiveBase.getReceiveId(), receiveBase.getDocumentId(), SynTag.DEAL));
        ExchangeSend exchangeSend = (ExchangeSend)this.dao.load(ExchangeSend.class, new Object[] { receiveBase.getReceiveId() });
        this.dao.delete(exchangeSend);
      } 
    } else {
      for (ReceiveBase receiveBase : receiveBaseList) {
        this.dao.save(new SendRecord(null, receiveBase.getReceiveId(), receiveBase.getDocumentId(), SynTag.FAILURE));
        ExchangeSend exchangeSend = (ExchangeSend)this.dao.load(ExchangeSend.class, new Object[] { receiveBase.getReceiveId() });
        this.dao.delete(exchangeSend);
      } 
    } 
  }
  
  @Transactional
  public void sendRET(ReceiveRecord receiveRecord) throws Exception {
    ReceiveBase receiveBase = (ReceiveBase)this.dao.load(ReceiveBase.class, new Object[] { receiveRecord.getReceiveId() });
    if (Null.isNull(receiveBase))
      throw new GdOAException("receiveBase is null; receiveId:" + receiveBase.getReceiveId()); 
    GdOAExchangeDept receiveDept = (GdOAExchangeDept)this.dao.load(GdOAExchangeDept.class, new Object[] { receiveRecord.getSenderDepartment() });
    GdOAExchangeDept sendDept = (GdOAExchangeDept)this.dao.load(GdOAExchangeDept.class, new Object[] { receiveRecord.getReceiverDepartment() });
    String type = getStateToString(receiveBase.getState());
    if (StringUtils.isBlank(type))
      return; 
    boolean result = sendRET(initSendShortDoc(sendDept.getExchangeDeptId(), sendDept.getDeptName(), receiveRecord.getSegmentId(), type, receiveDept.getExchangeDeptId(), receiveDept.getDeptName(), receiveRecord.getReceiveId()));
    if (result) {
      receiveRecord.setSendStateTag(SynTag.SUCCESS);
    } else {
      receiveRecord.setSendStateTag(SynTag.FAILURE);
    } 
    receiveRecord.setLastSynTag(type);
    receiveRecord.setSendSynTagTime(new Date());
    this.dao.save(receiveRecord);
  }
  
  @Transactional
  public void sendRET(SendRecord sendRecord) throws Exception {
    ReceiveBase receiveBase = (ReceiveBase)this.dao.load(ReceiveBase.class, new Object[] { sendRecord.getReceiveId() });
    Send send = this.dao.getSendByDocumentId(sendRecord.getDocumentId(), null);
    GdOAExchangeDept receiveDept = this.dao.getGdOAExchangeDeptByDeptId(receiveBase.getDeptId());
    GdOAExchangeDept sendDept = this.dao.getGdOAExchangeDeptByDeptId(send.getDeptId());
    String type = getStateToString(receiveBase.getState());
    if (StringUtils.isBlank(type))
      return; 
    boolean result = sendRET(initSendShortDoc(sendDept.getExchangeDeptId(), sendDept.getDeptName(), sendRecord.getSegmentId(), type, receiveDept.getExchangeDeptId(), receiveDept.getDeptName(), sendRecord.getReceiveId()));
    if (result) {
      sendRecord.setSendStateTag(SynTag.SUCCESS);
    } else {
      sendRecord.setSendStateTag(SynTag.FAILURE);
    } 
    sendRecord.setSendStateTime(new Date());
    this.dao.save(sendRecord);
  }
  
  private String getStateToString(ReceiveState state) {
    switch (null.$SwitchMap$com$gzzm$ods$exchange$ReceiveState[state.ordinal()]) {
      case 1:
      case 2:
      case 3:
        return "Accepted";
      case 4:
        return "Rejected";
      case 5:
      case 6:
        return "Recall";
    } 
    return null;
  }
  
  public boolean sendRET(SendShortDoc sendShortDoc) throws Exception {
    String jsonStr = SynTools.doPost(sendRET, sendShortDoc);
    boolean result = ResultUtils.isExchangePlatformSuccess((JsonObject)(new JsonParser(jsonStr)).parse());
    SendSynLog log = new SendSynLog(((JsonSerializer)(new JsonSerializer()).serialize(sendShortDoc)).toString().toCharArray(), jsonStr.toCharArray(), sendShortDoc.getSegment().getSegment_id(), sendRET, result);
    this.dao.save(log);
    return result;
  }
  
  public SendShortDoc initSendShortDoc(String senderDepartmentId, String senderDepartmentName, String segmentId, String type, String receiverDepartmentId, String receiverDepartmentName, Long receiveId) throws Exception {
    SendShortDoc sendShortDoc = new SendShortDoc();
    sendShortDoc.setSegment_type("RET");
    sendShortDoc.setSender_department(new SenderDepartment(senderDepartmentId, senderDepartmentName));
    if ("Recall".equals(type) || "RecallSuccess".equals(type)) {
      ReceiverDepartment receiver_department = new ReceiverDepartment();
      receiver_department.setDepartment_id(receiverDepartmentId);
      receiver_department.setDepartment_name(receiverDepartmentName);
      receiver_department.setDepartment_desc("");
      List<ReceiverDepartment> list = new ArrayList<>();
      list.add(receiver_department);
      sendShortDoc.setReceiver_department(list);
    } 
    SegmentRET segmentRET = new SegmentRET();
    segmentRET.setType(type);
    segmentRET.setTime(Long.valueOf(System.currentTimeMillis() / 1000L));
    segmentRET.setSegment_id(segmentId);
    sendShortDoc.setSegment(segmentRET);
    if ("Rejected".equals(type)) {
      Back back = this.dao.getBackByReceiveId(receiveId);
      if (back != null) {
        segmentRET.setOpinion(new String(back.getReason()));
        Extend ext = new Extend();
        List<Attrs> attrs = new ArrayList<>();
        attrs.add(new Attrs("op_user_name", back.getBackUser().getUserName()));
        attrs.add(new Attrs("op_user_phone", back.getBackUser().getPhone()));
        ext.setAttrs(attrs);
        sendShortDoc.setExt(ext);
      } 
    } 
    if ("Accepted".equals(type)) {
      ReceiveBase receiveBase = (ReceiveBase)this.dao.load(ReceiveBase.class, new Object[] { receiveId });
      Extend ext = new Extend();
      List<Attrs> attrs = new ArrayList<>();
      if (receiveBase.getReceiverUser() != null) {
        attrs.add(new Attrs("op_user_name", receiveBase.getReceiverUser().getUserName()));
        attrs.add(new Attrs("op_user_phone", receiveBase.getReceiverUser().getPhone()));
      } 
      ext.setAttrs(attrs);
      sendShortDoc.setExt(ext);
    } 
    return sendShortDoc;
  }
  
  public SendMainDoc createSendMainDoc(List<ReceiveBase> receiveBaseList, OfficeDocument document, Send send) throws Exception {
    String documentTextName;
    InputStream documentTextInputStream;
    Integer fileSize;
    SendMainDoc sendMainDoc = new SendMainDoc();
    sendMainDoc.setSegment_type("OFC");
    Segment segment = new Segment();
    SegmentContent segment_content = new SegmentContent();
    if (DocumentConstant.priorityList.contains(document.getPriority())) {
      segment_content.setEmergency_degree(document.getPriority());
    } else {
      segment_content.setEmergency_degree("无");
    } 
    segment_content.setSecurity_degree("无");
    Doc doc = new Doc();
    DocBody docbody = new DocBody();
    DocBodyExt docbodyExt = new DocBodyExt();
    docbody.setExt(docbodyExt);
    docbody.setVersion_code("1.0");
    Header header = new Header();
    Extend e = new Extend();
    List<Attrs> attrs2 = new ArrayList<>();
    attrs2.add(new Attrs("sender_name", send.getSendUser().getUserName()));
    attrs2.add(new Attrs("sender_phone", send.getSendUser().getPhone()));
    attrs2.add(new Attrs("title", document.getTitle()));
    e.setAttrs(attrs2);
    header.setExt(e);
    header.setSerial_number_of_copies("");
    header.setSecurity_Classification_And_Duration(new SecurityClassificationAndDuration());
    if (DocumentConstant.priorityList.contains(document.getPriority())) {
      segment_content.setEmergency_degree(document.getPriority());
    } else {
      segment_content.setEmergency_degree("无");
    } 
    header.setIdentification_of_document_issuer(new IdentificationOfDocumentIssuer(document.getSourceDept(), ""));
    if (StringUtils.isNotBlank(document.getSendNumber()))
      header.setIssued_number_of_document(createIssuedNumberOfDocument(document)); 
    header.setSigner(document.getSigner());
    docbody.setHeader(header);
    MainBody mainBody = new MainBody();
    DocumentText text = document.getText();
    if (StringUtils.isNotBlank(text.getOtherFileName())) {
      documentTextName = text.getOtherFileName();
      documentTextInputStream = text.getOtherFile();
    } else {
      documentTextName = document.getTitle() + "." + text.getType();
      documentTextInputStream = text.getTextBody();
    } 
    mainBody.setDocument_title(documentTextName);
    mainBody.setMain_receiver_department(getSendType(receiveBaseList, "主送"));
    if (documentTextInputStream != null)
      mainBody.setMain_body(FileUtils.uploadFile(documentTextInputStream, documentTextName)); 
    if (document.getText().getFileSize() != null) {
      fileSize = Integer.valueOf(document.getText().getFileSize().intValue());
    } else {
      fileSize = Integer.valueOf(document.getText().getOtherFileSize().intValue());
    } 
    mainBody.setMain_body_size(fileSize.intValue());
    mainBody.setAttachment_explain("");
    List<Attachment> gdAttachmentList = new ArrayList<>();
    if (CollectionUtils.isNotEmpty(document.getAttachments()))
      for (Attachment attachment : document.getAttachments()) {
        String attachmentBody = FileUtils.uploadFile(attachment.getContent().getInputStream(), attachment.getAttachmentName());
        gdAttachmentList.add(new Attachment(attachment.getAttachmentName(), attachmentBody, attachment.getSize()));
      }  
    mainBody.setAttachment(gdAttachmentList);
    List<Attrs> attrs1 = new ArrayList<>();
    attrs1.add(new Attrs("file_ext", document.getText().getType()));
    mainBody.setExt(new Extend(attrs1));
    mainBody.setSignature_of_document_issuing_agency(new SignatureOfDocumentIssuingAgency(document.getSigner(), ""));
    Date finalDate = document.getFinalTime();
    if (finalDate == null)
      finalDate = send.getSendTime(); 
    mainBody.setIssued_date_of_document(TimeUtils.toString(finalDate));
    docbody.setBody(mainBody);
    Tail tail = new Tail();
    tail.setSend_to_department(document.getSourceDept());
    tail.setExt(new Extend());
    docbody.setTail(tail);
    doc.setBody(docbody);
    segment_content.setDoc(doc);
    GdOAExchangeDept sendDept = this.dao.getGdOAExchangeDeptByDeptId(send.getDeptId());
    if (sendDept == null)
      throw new GdOAException("send exchangeDept is null; deptId" + send.getDeptId()); 
    segment.setSender_department(new SenderDepartment(sendDept.getExchangeDeptId(), sendDept.getDeptName()));
    List<ReceiverDepartment> list = new ArrayList<>();
    for (ReceiveBase receiveBase : receiveBaseList) {
      GdOAExchangeDept receiveDept = this.dao.getGdOAExchangeDeptByDeptId(receiveBase.getDeptId());
      list.add(new ReceiverDepartment(receiveDept.getExchangeDeptId(), receiveDept.getDeptName()));
    } 
    segment.setReceiver_department(list);
    segment.setSegment_content(segment_content);
    sendMainDoc.setSegment(segment);
    return sendMainDoc;
  }
  
  public IssuedNumberOfDocument createIssuedNumberOfDocument(OfficeDocument document) {
    IssuedNumberOfDocument issuedNumberOfDocument = new IssuedNumberOfDocument();
    try {
      if (StringUtils.isNotBlank(document.getSendNumber())) {
        issuedNumberOfDocument.setIssued_department_code(getIssuedDepartmentCode(document.getSendNumber()));
        issuedNumberOfDocument.setYear(getYear(document.getSendNumber()));
        issuedNumberOfDocument.setIssued_sequence(getIssuedSequence(document.getSendNumber()));
      } 
    } catch (Exception e) {
      Tools.log(e);
      issuedNumberOfDocument.setIssued_department_code(document.getSendNumber());
      issuedNumberOfDocument.setIssued_sequence("");
      issuedNumberOfDocument.setYear("");
    } 
    return issuedNumberOfDocument;
  }
  
  private String getIssuedSequence(String sendNumber) throws Exception {
    return sendNumber.substring(sendNumber.lastIndexOf("〕") + 1, sendNumber.lastIndexOf("号"));
  }
  
  private String getYear(String sendNumber) throws Exception {
    return sendNumber.substring(sendNumber.lastIndexOf("〔") + 1, sendNumber.lastIndexOf("〕"));
  }
  
  private String getIssuedDepartmentCode(String sendNumber) throws Exception {
    return sendNumber.substring(0, sendNumber.lastIndexOf("〔"));
  }
  
  private String getSendType(List<ReceiveBase> receiveBaseList, String sendType) {
    if (CollectionUtils.isNotEmpty(receiveBaseList)) {
      StringBuilder sb = new StringBuilder();
      for (ReceiveBase receiveBase : receiveBaseList) {
        if (sendType.equals(receiveBase.getSendType())) {
          if (sb.length() > 0)
            sb.append(","); 
          sb.append(receiveBase.getDept().getDeptName());
        } 
      } 
      return sb.toString();
    } 
    return "";
  }
  
  public void sendDocument() throws Exception {
    List<ReceiveBase> documentReceiveList = null;
    try {
      List<ReceiveBase> turnReceiveBaseList = this.dao.getExchangeSendList(null);
      List<Long> sendDocumentList = null;
      while (CollectionUtils.isNotEmpty(turnReceiveBaseList)) {
        sendDocumentList = new ArrayList<>();
        for (ReceiveBase receiveBase : turnReceiveBaseList) {
          Long documentId = receiveBase.getDocumentId();
          if (sendDocumentList.contains(documentId))
            continue; 
          sendDocumentList.add(documentId);
          documentReceiveList = this.dao.getExchangeSendList(documentId);
          if (CollectionUtils.isEmpty(documentReceiveList))
            throw new GdOAException("receiveBaseList exchangeDept isEmpty; documentId:" + documentId); 
          OfficeDocument document = (OfficeDocument)this.dao.load(OfficeDocument.class, new Object[] { documentId });
          if (Null.isNull(document))
            throw new GdOAException("document is null; documentId:" + documentId); 
          Send send = this.dao.getSendByDocumentId(documentId, SendState.sended);
          if (Null.isNull(send))
            throw new GdOAException("send is null; documentId:" + documentId); 
          sendOFC(documentReceiveList, document, send);
        } 
        turnReceiveBaseList = this.dao.getExchangeSendList(null);
      } 
    } catch (Exception e) {
      if (CollectionUtils.isNotEmpty(documentReceiveList))
        for (ReceiveBase receiveBase : documentReceiveList) {
          this.dao.save(new SendRecord(null, receiveBase.getReceiveId(), receiveBase.getDocumentId(), SynTag.FAILURE));
          ExchangeSend exchangeSend = (ExchangeSend)this.dao.load(ExchangeSend.class, new Object[] { receiveBase.getReceiveId() });
          this.dao.delete(exchangeSend);
        }  
      Tools.log(e);
      ErrorLog log = SynTools.markErrorMsg(sendOFC, "sendOFC", e);
      this.dao.save(log);
    } 
  }
  
  public void sendDocumentState() throws Exception {
    try {
      List<ReceiveRecord> receiveRecordList = this.dao.getReceiveRecordToRET();
      while (CollectionUtils.isNotEmpty(receiveRecordList)) {
        for (ReceiveRecord receive : receiveRecordList)
          sendRET(receive); 
        receiveRecordList = this.dao.getReceiveRecordToRET();
      } 
      List<SendRecord> sendRecordList = this.dao.getWithdrawnSendRecord();
      while (CollectionUtils.isNotEmpty(sendRecordList)) {
        for (SendRecord sendRecord : sendRecordList)
          sendRET(sendRecord); 
        sendRecordList = this.dao.getWithdrawnSendRecord();
      } 
    } catch (Exception e) {
      Tools.log(e);
      ErrorLog log = SynTools.markErrorMsg(sendRET, "sendRET", e);
      this.dao.save(log);
    } 
  }
}
